#include <malloc.h>
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "..\scrypt\scrypt.h"

int password_edit(TCHAR *password) {
	TCHAR out_pass[256];
	BOOL show_pass, insert;
	HANDLE hConsole;
	CONSOLE_SCREEN_BUFFER_INFO console_info;
	int y_init;
	CONSOLE_CURSOR_INFO cursor;
	DWORD cursor_size;
	HKEY reg_key;
	DWORD n_bytes;
	TCHAR c, prev_c = 0, c_overwritten = 0;
	DWORD prev_time = 0;
	int i, j, n;

	ZeroMemory(password, 512);
	hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(hConsole, &console_info);
	i = n = 250 / console_info.dwSize.X;
	while (n--) _putch('\n');
	GetConsoleScreenBufferInfo(hConsole, &console_info);
	console_info.dwCursorPosition.Y -= i;
	SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
	y_init = console_info.dwCursorPosition.Y;
	GetConsoleCursorInfo(hConsole, &cursor);
	if (RegOpenKeyEx(HKEY_CURRENT_USER, L"Console", 0, KEY_QUERY_VALUE, &reg_key) == ERROR_SUCCESS) {
		n_bytes = sizeof cursor.dwSize;
		RegQueryValueEx(reg_key, L"CursorSize", NULL, NULL, (void*)&cursor.dwSize, &n_bytes);
		RegCloseKey(reg_key);
		SetConsoleCursorInfo(hConsole, &cursor);
	}
	cursor_size = cursor.dwSize;
	show_pass = FALSE;
	insert = TRUE;
	i = n = 0;
	for (;;) {
		c = _getwch();
		if (c == '\r' || c == 27) {
			show_pass = FALSE;
			break;
		}
		if (!c) {
			_getwch();
			continue;
		}
		if (c == '\t') show_pass = !show_pass;
		else if (c == '\b') {
			if (i) {
				for (j = i; j < n; j++) password[j - 1] = password[j];
				password[--n] = 0;
				i--;
			}
		}
		else if (prev_c == 224 && c != 224 && GetTickCount() - prev_time < 100) {
			if (n < 250) {
				if (insert) {
					for (j = --i; j < n; j++) password[j] = password[j + 1];
					n--;
				} else {
					if (!c_overwritten) n--;
					password[--i] = c_overwritten;
				}
			}
			switch (c) {
				case 75: // backward
					if (i) i--;
					break;
				case 77 : // forward
					if (i < n) i++;
					break;
				case 82: // insert
					cursor.dwSize = (insert = !insert) ? cursor_size : 100;
					SetConsoleCursorInfo(hConsole, &cursor);
					break;
				case 83: // delete
					for (j = i; j < n; j++) password[j] = password[j + 1];
					if (i < n) n--;
					break;
					i = 0;
					break;
				case 79: // end
				case 71: // home
					i = n;
			}
		} else if (n < 250) {
			if (insert) {
				for (j = n; j > i; j--) password[j] = password[j - 1];
				n++;
			} else {
				c_overwritten = password[i];
				if (i == n) n++;
			}
			password[i++] = c;
		}
		j = 0;
		do out_pass[j] = show_pass ? password[j] : '*'; while (password[j++]);
		out_pass[j - 1] = ' ';
		out_pass[j] = ' ';
		out_pass[j + 1] = 0;
		console_info.dwCursorPosition.X = 0;
		console_info.dwCursorPosition.Y = y_init;
		SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
		_cwprintf(L"%s", out_pass);
		console_info.dwCursorPosition.X = i % console_info.dwSize.X;
		console_info.dwCursorPosition.Y = i / console_info.dwSize.X + y_init;
		SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
		prev_c = c;
		prev_time = GetTickCount();
	}
	j = 0;
	do out_pass[j] = '*'; while (password[j++]);
	out_pass[j - 1] = ' ';
	out_pass[j] = ' ';
	out_pass[j + 1] = 0;
	console_info.dwCursorPosition.X = 0;
	console_info.dwCursorPosition.Y = y_init;
	SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
	_cwprintf(L"%s\n", out_pass);
	cursor.dwSize = cursor_size;
	SetConsoleCursorInfo(hConsole, &cursor);

	return c == 27;
}

int rand_gen(unsigned char *buf, int size, int prf, DWORD init_time)
{
	HCRYPTPROV hProv;
	unsigned char *pool1, *pool2;
	int half_size = size / 2;
	POINT curs_pos;

	AttachConsole(ATTACH_PARENT_PROCESS);
	pool1 = _aligned_malloc(size + 4, 16);
	pool2 = _aligned_malloc(size + 4, 16);

	if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, 0) && !CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_NEWKEYSET)) {
		wprintf(L"CryptAcquireContext() failed.\n");
		return 1;
	}

	if (!CryptGenRandom(hProv, size, pool1)) {
		wprintf(L"CryptGenRandom() failed.\n");
		return 1;
	}
	((DWORD*)pool1)[0] += init_time;
	if (scrypt(prf, pool1, half_size, pool1 + half_size, half_size, 32768, 16, 1, pool2, size)) {
		wprintf(L"Cannot allocate memory for scrypt.\n");
		return 1;
	}
	if (!CryptGenRandom(hProv, size, pool2)) {
		wprintf(L"CryptGenRandom() failed.\n");
		return 1;
	}
	CryptReleaseContext(hProv, 0);
	((DWORD*)pool2)[0] += GetTickCount() - init_time;
	GetCursorPos(&curs_pos);
	((DWORD*)pool2)[1] += curs_pos.x;
	((DWORD*)pool2)[2] += curs_pos.y;
	if (scrypt(prf, pool2, half_size, pool2 + half_size, half_size, 32768, 16, 1, pool1, size)) {
		wprintf(L"Cannot allocate memory for scrypt.\n");
		return 1;
	}

	memcpy(buf, pool1, size);
	SecureZeroMemory(pool1, size + 4);
	SecureZeroMemory(pool2, size + 4);
	_aligned_free(pool2);
	_aligned_free(pool1);

	return 0;
}
