#include <intrin.h>

typedef struct {
	unsigned char key[32];
	__m128i subkeys[33][4];
} serpent_key;

void serpent_init(serpent_key *key);
void serpent_close(serpent_key *key);
void serpent_encrypt(serpent_key *key, unsigned char *buffer);
void serpent_decrypt(serpent_key *key, unsigned char *buffer);
